## AtkStreamableContent AtkStreamableContent — The ATK interface which provides access to streamable content. |

## Functions

gint | atk_streamable_content_get_n_mime_types ()
const gchar * | atk_streamable_content_get_mime_type ()
GIOChannel * | atk_streamable_content_get_stream ()
const gchar * | atk_streamable_content_get_uri ()

## Types and Values

| AtkStreamableContent

## Object Hierarchy

        GInterface
        ╰── AtkStreamableContent

## Includes

    #include <atk/atk.h>

## Description

An interface whereby an object allows its backing content to be streamed to clients. Typical implementors would be images or icons, HTML content, or multimedia display/rendering widgets.

Negotiation of content type is allowed. Clients may examine the backing data and transform, convert, or parse the content in order to present it in an alternate form to end-users.

The AtkStreamableContent interface is particularly useful for saving, printing, or post-processing entire documents, or for persisting alternate views of a document. If document content itself is being serialized, stored, or converted, then use of the AtkStreamableContent interface can help address performance issues. Unlike most ATK interfaces, this interface is not strongly tied to the current user-agent view of the a particular document, but may in some cases give access to the underlying model data.

## Functions

### atk_streamable_content_get_n_mime_types ()

    gint
    atk_streamable_content_get_n_mime_types
                                   (AtkStreamableContent *streamable);

Gets the number of mime types supported by this object.

#### Parameters

streamable | a GObject instance that implements AtkStreamableContentIface |

#### Returns

a gint which is the number of mime types supported by the object.

### atk_streamable_content_get_mime_type ()

    const gchar *
    atk_streamable_content_get_mime_type (AtkStreamableContent *streamable,
                                          gint i);

Gets the character string of the specified mime type. The first mime type is at position 0, the second at position 1, and so on.

#### Parameters

streamable | a GObject instance that implements AtkStreamableContent |
i | a gint representing the position of the mime type starting from 0 |

#### Returns

a gchar* representing the specified mime type; the caller should not free the character string.

### atk_streamable_content_get_stream ()

    GIOChannel *
    atk_streamable_content_get_stream (AtkStreamableContent *streamable,
                                       const gchar *mime_type);

Gets the content in the specified mime type.

#### Parameters

streamable | a GObject instance that implements AtkStreamableContentIface |
mime_type | a gchar* representing the mime type |

#### Returns

A GIOChannel which contains the content in the specified mime type.

[transfer full]

### atk_streamable_content_get_uri ()

    const gchar *
    atk_streamable_content_get_uri (AtkStreamableContent *streamable,
                                    const gchar *mime_type);

Get a string representing a URI in IETF standard format (see http://www.ietf.org/rfc/rfc2396.txt) from which the object's content may be streamed in the specified mime-type, if one is available. If mime_type is NULL, the URI for the default (and possibly only) mime-type is returned.

Note that it is possible for get_uri to return NULL but for get_stream to work nonetheless, since not all GIOChannels connect to URIs.

#### Parameters

streamable | a GObject instance that implements AtkStreamableContentIface |
mime_type | a gchar* representing the mime type, or NULL to request a URI for the default mime type. |

#### Returns

Returns a string representing a URI, or `NULL` if no corresponding URI can be constructed.

[nullable]

Since: 1.12

## Types and Values

### AtkStreamableContent

    typedef struct _AtkStreamableContent AtkStreamableContent;